{$C FIXED PRELOAD PERMANENT}
unit Com_Foss;

interface

uses Comm;
{ Com_Fosi;
  by Eric Molitor, emolitor@juno.com
  Copyright 1997 Eric Molitor
  Public Domain

  Used to manipulate a single comport utilizing FOSSIL routines.

  Sources Cited
    Turbo Pascal 7.0
      by Borland International
    functions Reference Manual For The X00 Developer
      by Raymond L. Gwinn
    Fossil Wizard Unit v1.0
      by Steve Connet }
type
  {$IFDEF _DPMI}
    RealModeRegs  = Record
     Case Integer Of
      0: ( EDI, ESI, EBP, EXX, EBX, EDX, ECX, EAX: Longint;
           Flags, ES, DS, FS, GS, IP, CS, SP, SS: Word) ;
      1: ( DI,DIH, SI, SIH, BP, BPH, XX, XXH: Word;
       Case Integer of
        0: (BX, BXH, DX, DXH, CX, CXH, AX, AXH: Word);
        1: (BL, BH, BLH, BHH, DL, DH, DLH, DHH,
            CL, CH, CLH, CHH, AL, AH, ALH, AHH: Byte));
     end;
 {$ENDIF}
  PFossil_Object = ^TFossil_Object;
  TFossil_Object = object(TComm)
       constructor Init (Comport:Byte; FlowState:byte);
       destructor Done; virtual;
       procedure Setup (Baud:longint; DataBits:byte; Parity:CHAR; Stop:byte); virtual;
       procedure Dtr (State:boolean);  virtual;
       procedure Flow (State:byte); virtual;
       function  Carrier:boolean; virtual;
       procedure ClearOut; virtual;
       procedure ClearIn; virtual;
       procedure FlushOut; virtual;
       function  Received:boolean; virtual;
       function  Receive:CHAR; virtual;
       procedure Send (Character:CHAR); virtual;
       function  Ring:boolean; virtual;
       procedure HangUp; virtual;
       procedure SetBaud(Baud: LongInt);  virtual;
       function  GetBaud: LongInt;  virtual;
       function  TxReady : boolean; virtual;
       procedure PutBlock(var Buf; Size: Word);
  end;

implementation
uses Dos, Crt;

(*--------------------------------------------------------------------------*)
 var
   {$IFDEF _DPMI}
    Regs: RealModeRegs;
   {$ELSE}
    Regs: Registers;
   {$ENDIF}

(*--------------------------------------------------------------------------*)
procedure Clear_Regs;
  begin
    FillChar(Regs, SizeOf(Regs), 0);
  end;

(*--------------------------------------------------------------------------*)

{$IFDEF _DPMI}
function RealModeInt(IntNo : Byte; Var RealRegs : RealModeRegs) : boolean; assembler;
asm
  MOV AX, 0300h
  MOV BL, [IntNo]
  XOR BH, BH
  XOR CX, CX
  LES DI, [RealRegs]
  INT 31h
  JC  @Error
  MOV AX, 1
  JMP @Exit
@Error:
  MOV AX, 0
@Exit:
end;
{$ENDIF}

constructor TFossil_Object.Init(Comport: byte; FlowState:byte);
  begin
    inherited Init;
    UsedPort := Comport - 1;
    Clear_Regs;
    Regs.AH := 4;
    Regs.DX := (UsedPort);
   {$IFDEF _DPMI}
    RealModeInt($14, Regs);
   {$ELSE}
   Intr($14, Regs);
   {$ENDIF}
    if Regs.AX <> $1954 then
        begin
        {
          Writeln('ERROR: Port Settings Invalid or Fossil Not Loaded!');
        }
        end;
    Flow (FlowState);
  end;

(*--------------------------------------------------------------------------*)
destructor TFossil_Object.Done;
begin
  inherited Done;
  Clear_Regs;
  Dtr(False);
  Regs.AH := 5;
  Regs.DX := (UsedPort);
 {$IFDEF _DPMI}
  RealModeInt($14, Regs);
 {$ELSE}
 Intr($14, Regs);
 {$ENDIF}
end;

(*--------------------------------------------------------------------------*)
procedure TFossil_Object.Setup(Baud: longint; DataBits: byte; Parity: Char; Stop: byte);
var
 Code: Integer;

begin
 Code := 0;
 Clear_Regs;
 if Baud > 19200 then
  begin
   code := code + 000 + 00 + 32;
  end else
  begin
   case Baud Of
     0: EXIT;
     300: code := code + 000 + 64 + 00;
     600: code := code + 000 + 64 + 32;
     1200: code := code + 128 + 00 + 00;
     2400: code := code + 128 + 00 + 32;
     4800: code := code + 128 + 64 + 00;
     9600: code := code + 128 + 64 + 32;
     19200: code := code + 000 + 00 + 00 else
       code := code + 000 + 00 + 32;
   end;
  end;
 case DataBits Of
   5: code := code + 0 + 0;
   6: code := code + 0 + 1;
   7: code := code + 2 + 0;
   8: code := code + 2 + 1;
 end;
 case Parity Of
   'N', 'n': code := code + 00 + 0;
   'O', 'o': code := code + 00 + 8;
   'E', 'e': code := code + 16 + 8;
 end;
 case Stop Of
   1: code := code + 0;
   2: code := code + 4;
 end;
 Regs.AH := 0;
 Regs.AL := Code;
 Regs.DX := (UsedPort);
 {$IFDEF _DPMI}
  RealModeInt($14, Regs);
 {$ELSE}
 Intr($14, Regs);
 {$ENDIF}
end;

(*--------------------------------------------------------------------------*)
procedure TFossil_Object.Dtr(State: boolean);
begin
 Clear_Regs;
 Regs.AH := 6;
 Regs.DX := (UsedPort);
 case State Of
   True: Regs.AL := 1;
   False: Regs.AL := 0;
 end;
 {$IFDEF _DPMI}
  RealModeInt($14, Regs);
 {$ELSE}
 Intr($14, Regs);
 {$ENDIF}
end;

(*--------------------------------------------------------------------------*)
function TFossil_Object.Carrier: boolean;
begin
 inherited Carrier;
 Clear_Regs;
 Regs.AH := 3;
 Regs.DX := (UsedPort);
 {$IFDEF _DPMI}
  RealModeInt($14, Regs);
 {$ELSE}
 Intr($14, Regs);
 {$ENDIF}
 Carrier := ((Regs.AL And 128) = 128);
end;

(*--------------------------------------------------------------------------*)
procedure TFossil_Object.Flow(State: byte);
begin
 Clear_Regs;
 Regs.AH := 15;
 Regs.DX := UsedPort;
 case State Of
    0: Regs.AL:= 2;
    1: Regs.AL:= 9;
    2: Regs.AL:= 11;
  else
 Regs.AL := 0;
 end;
 {$IFDEF _DPMI}
  RealModeInt($14, Regs);
 {$ELSE}
 Intr($14, Regs);
 {$ENDIF}
end;

(*--------------------------------------------------------------------------*)
procedure TFossil_Object.ClearOut;
begin
 Clear_Regs;
 Regs.AH := 9;
 Regs.DX := UsedPort;
 {$IFDEF _DPMI}
  RealModeInt($14, Regs);
 {$ELSE}
 Intr($14, Regs);
 {$ENDIF}
end;

(*--------------------------------------------------------------------------*)
procedure TFossil_Object.ClearIn;
begin
 Clear_Regs;
 Regs.AH := 10;
 Regs.DX := UsedPort;
 {$IFDEF _DPMI}
  RealModeInt($14, Regs);
 {$ELSE}
 Intr($14, Regs);
 {$ENDIF}
end;


(*--------------------------------------------------------------------------*)
procedure TFossil_Object.FlushOut;
begin
 Clear_Regs;
 Regs.AH := 8;
 Regs.DX := UsedPort;
 {$IFDEF _DPMI}
  RealModeInt($14, Regs);
 {$ELSE}
 Intr($14, Regs);
 {$ENDIF}
end;

(*--------------------------------------------------------------------------*)
function TFossil_Object.Received: boolean;
begin
 inherited Received;
 Clear_Regs;
 Regs.AH := 3;
 Regs.DX := UsedPort;
 {$IFDEF _DPMI}
  RealModeInt($14, Regs);
 {$ELSE}
 Intr($14, Regs);
 {$ENDIF}
 Received := ((Regs.AH And 1) = 1);
end;

(*--------------------------------------------------------------------------*)
procedure TFossil_Object.Send(Character: Char);
begin
 inherited Send(Character);
 Clear_Regs;
 Regs.AH := 1;
 Regs.DX := UsedPort;
 Regs.AL := ORD(Character);
 {$IFDEF _DPMI}
  RealModeInt($14, Regs);
 {$ELSE}
 Intr($14, Regs);
 {$ENDIF}
{ if (Regs.AH and 128)=128 then SendBreak;}
end;

(*--------------------------------------------------------------------------*)
function TFossil_Object.Receive: Char;
begin
 inherited Receive;
 Clear_Regs;
 Regs.AH := 2;
 Regs.DX := UsedPort;
 {$IFDEF _DPMI}
  RealModeInt($14, Regs);
 {$ELSE}
 Intr($14, Regs);
 {$ENDIF}
{ if (Regs.AH and 128)=128 then SendBreak;}
 Receive := Chr(Regs.AL);
end;

(*--------------------------------------------------------------------------*)
function TFossil_Object.Ring: boolean;
begin
 Regs.ah := $03;
 Regs.dx := UsedPort;
 {$IFDEF _DPMI}
  RealModeInt($14, Regs);
 {$ELSE}
 Intr($14, Regs);
 {$ENDIF}
 Ring := (Regs.AL And $40) = $40
end;

function  TFossil_Object.TxReady : boolean;
var
 Carr, THRE : boolean;
begin
  inherited TxReady;
  Clear_Regs;
  Regs.AH := 3;
  Regs.DX := UsedPort;
  {$IFDEF _DPMI}
   RealModeInt($14, Regs);
  {$ELSE}
   Intr($14, Regs);
  {$ENDIF}
  THRE := (Regs.AH and $20) <> 0;
  {
  Carr := (Regs.AX and $0080) <> 0;
  }
  TxReady := THRE;
end;

(*--------------------------------------------------------------------------*)
procedure TFossil_Object.HangUp;
var
 Tcount: Integer;
begin
 Dtr(False);
 Delay(600);
 Dtr(True);
 if Carrier = True then
  begin
    Tcount := 1;
    repeat
      Send('+');
      Send('+');
      Send('+');
      Send(Char(13));
      Delay(3000);
      Send('A');
      Send('T');
      Send('H');
      Send('0');
      Send(Char(13));
      Delay(3000);
      if Carrier = False
        then
          tcount := 3;
      Tcount := Tcount + 1;
    until Tcount = 4;
  end;
end;

procedure TFossil_Object.SetBaud(Baud: LongInt);
var
 BaudRate    : Byte;
 Temp0       : Integer;
 CPort: Word;
begin
  Temp0 := baud Div 10;
  Case Temp0 of
      30 : BaudRate := $43;
      60 : BaudRate := $63;
     120 : BaudRate := $83;
     240 : BaudRate := $A3;
     480 : BaudRate := $C3;
     960 : BaudRate := $E3;
    1920 : BaudRate := $03;
    3840 : BaudRate := $23;
    5760 : BaudRate := $23;
  End;
  CPort:=UsedPort;
  {
  asm
   XOR AH,AH
   MOV AL,BaudRate
   MOV DX,CPort
   INT 14h
  end
  }
end;

procedure TFossil_Object.PutBlock(var Buf; Size: Word);
type
 TBuf = array [0..$FFF0] of char;
var
 I: Word;
begin
 for i:=0 to Size-1 do Send(TBuf(Buf)[i]);
end;

function TFossil_Object.GetBaud: LongInt;
begin

end;

end.
